Attribute VB_Name = "math"
Option Explicit

'*****
'takes a string, returns an integer representing the hex value of the string
Public Function Hex2Dec(value As String)

    Dim DecValue, count As Integer
    
    value = UCase(value)
    
    DecValue = 0
        
    For count = Len(value) To 1 Step -1
        If Asc(Mid(value, count, 1)) <= Asc("9") And Asc(Mid(value, count, 1)) >= Asc("0") Then
            DecValue = DecValue + (Asc(Mid(value, count, 1)) - Asc("0")) * (16 ^ (Len(value) - count))
        ElseIf Asc(Mid(value, count, 1)) <= Asc("F") And Asc(Mid(value, count, 1)) >= Asc("A") Then
            DecValue = DecValue + ((Asc(Mid(value, count, 1)) - Asc("A") + 10)) * (16 ^ (Len(value) - count))
        End If
    Next count
        
    Hex2Dec = DecValue
            
End Function
Public Function Maxi(num1 As Variant, num2 As Variant) As Variant
    If num1 > num2 Then
        Maxi = num1
    Else
        Maxi = num2
    End If
End Function

Public Function Mini(num1 As Variant, num2 As Variant) As Variant
    If num1 < num2 Then
        Mini = num1
    Else
        Mini = num2
    End If
End Function
'takes a truncated double and produces a string, exactly 24 digits long
Public Function TruncedDouble2String(d As Double) As String
 Dim temp As String
 Dim i As Variant
 
 temp = ""
 For i = 23 To 0 Step -1
   temp = temp + Chr(Int(d / (10 ^ i)) + Asc("0"))
  d = d - (Int(d / (10 ^ i)) * 10 ^ i)
 Next i
 
 TruncedDouble2String = temp

End Function
'given two 24-digit byte arrays, ie:
'a(23..0)={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9}
'b(23..0)={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4}
'returns result
'c(23..0)={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,3}
'there is no overflow checking
Public Function Add24DigitByteArrays(a() As Byte, b() As Byte) As Variant

 Dim i As Variant

 'first convert both strings into 24 digit byte arrays
' For i = 23 To 0 Step -1
'  ByteArrayA(i) = Asc(Mid(a, 24 - i, 1))
' Next i
' For i = 24 To 1 Step -1
'  ByteArrayB(i) = Asc(Mid(b, 24 - i, 1))
' Next i
 
 For i = 23 To 0 Step -1
  a(i) = a(i) + b(i)
  If (a(i) >= 10) Then
   a(i) = a(i) - 10
   a(i + 1) = a(i + 1) + 1
  End If
 Next i
 
 Add24DigitByteArrays = a
 
End Function
'given a 24-digit byte array, ie:
'a(23..0)={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9}
'returns plain string, fixed length of "000000000000000000009"
Public Function Convert24DigitByteArray2StringFixedPlain(a() As Byte) As String
 Dim i As Variant
 Dim temp As String
  
 temp = ""
 For i = 23 To 0 Step -1
  temp = temp + Chr(a(i) + Asc("0"))
 Next i
 Convert24DigitByteArray2StringFixedPlain = temp
End Function


'given a 24-digit byte array, ie:
'a(23..0)={0,0,0,0,0,0,0,0,0,0,0,0,1,2,3,4,5,6,7,8,9}
'returns string, smallest length, with commas, of "123,456,789"
Public Function Convert24DigitByteArray2StringSmallCommas(a() As Byte) As String
 Dim i As Variant
 Dim temp As String
 Dim SkipLeadingZeroFlag As Boolean
 
 SkipLeadingZeroFlag = True
 temp = ""
 For i = 23 To 0 Step -1
  If a(i) > 0 Or SkipLeadingZeroFlag = False Then
   SkipLeadingZeroFlag = False
   
   temp = temp + Chr(a(i) + Asc("0"))
   If i Mod 3 = 0 And i <> 0 Then temp = temp + ","
  End If
 Next i
 Convert24DigitByteArray2StringSmallCommas = temp
End Function
'given a 24-digit byte array, ie:
'a(23..0)={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9}
'returns double of 9
Public Function Convert24DigitByteArray2Double(a() As Byte) As Double
 Dim i As Variant
 Dim temp As Double
 
 temp = 0
 For i = 23 To 0 Step -1
  temp = temp + a(i) * (10 ^ i)
 Next i
 Convert24DigitByteArray2Double = temp
End Function
