Attribute VB_Name = "serial"
Option Explicit
Dim timeoutflag As Byte
'*****
'opens serial port
Public Function openport() As Boolean
Dim msg As Variant
    
On Error GoTo ErrorHandler              'trap errors
    
 If Debt.MSComm1.PortOpen = True Then
     Debt.MSComm1.PortOpen = False
 End If
 Debt.MSComm1.InputMode = comInputModeBinary
 Debt.MSComm1.PortOpen = True
 Debt.MSComm1.InputLen = 1
 clearbuffer
 
 openport = True
 Exit Function
    
ErrorHandler:
 Select Case Err.Number
     Case 9                          'port not open
         openport = False
         Exit Function
     Case 8002                       'could not open port
         openport = False
         Exit Function
     Case 8005                       'port already open
         openport = False
         Exit Function
     Case 8012                       'invalid port number
         openport = False
         Exit Function
     Case Else
         msg = "WARNING: Error " & Str(Err.Number) & " was generated by " _
         & Err.Source & Chr(13) & Err.Description _
         & Chr(13) & "Please consult Visual Basic 5 Documentation"
         MsgBox msg, , "Error", Err.HelpFile, Err.HelpContext
         Exit Function
 End Select
    
End Function
'*****
'opens serial port
Public Sub closeport()
    If Debt.MSComm1.PortOpen = True Then
        Debt.MSComm1.PortOpen = False
    End If
End Sub
'*****
'sends byte to serial port
Public Sub putch(data As Byte)
    Dim x(0) As Byte
    x(0) = data
    Debt.MSComm1.Output = x
End Sub
'*****
'returns byte waiting on serial port
Function getch() As Byte

On Error GoTo ErrorHandler              'trap errors
    
    Dim msg As String
    Dim x() As Byte
    
    Dim timenow As Double
    
    'wait for character to arrive, max 2.4 seconds
    timenow = Timer
    Do
        DoEvents
    Loop Until Debt.MSComm1.InBufferCount >= 1 Or Timer > timenow + 2.5
    
    If Timer > timenow + 2.4 Then
        timeoutflag = True
    Else
        timeoutflag = False
    End If
    
    Debt.MSComm1.InputLen = 1
    x = Debt.MSComm1.Input
    
    getch = x(0)
    
    Exit Function
    
ErrorHandler:
            Select Case Err.Number
                Case 9                          'port not open
                    Exit Function
                Case Else
                    msg = "WARNING: Error " & Str(Err.Number) & " was generated by " _
                    & Err.Source & Chr(13) & Err.Description _
                    & Chr(13) & "Please consult Visual Basic 5 Documentation"
                    MsgBox msg, , "Error", Err.HelpFile, Err.HelpContext
                    Exit Function
            End Select

End Function
'*****
'clears all chars waiting in serial buffer
Public Function clearbuffer()
    Debt.MSComm1.InBufferCount = 0
End Function
'*****
'indicates whether a serial timeout has occurred or not
Public Function timeout() As Byte
    timeout = timeoutflag
End Function

'*****
'returns an array of bytes from the serial port
Public Function getarray(size As Byte) As Variant
    Dim data() As Byte
    
    Dim timenow As Double
    
    timenow = Timer

    While Debt.MSComm1.InBufferCount <= size And Timer < timenow + 5  'wait until buffer has whole line, picturewidth + 1 for checksum
        DoEvents
    Wend

    If Timer > timenow + 4.95 Then  'timed out
        timeoutflag = True
    Else
        timeoutflag = False
    End If

    'line has been received (whole line in input buffer)
    Debt.MSComm1.InputLen = 0
    data = Debt.MSComm1.Input  'copy line data from input buffer to variable
    getarray = data
    
End Function

Public Function sendarray(ParamArray data() As Variant)

    
    
    Debt.MSComm1.Output = data(0)

    While Debt.MSComm1.OutBufferCount > 0
        DoEvents
    Wend

End Function
 
